﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.display.Stage;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	
	
	public class Timeline extends Sprite
	{
		private var _screen:BitmapData;
		private var bitmap:Bitmap;
		private var cursor:Sprite;
		private var sketch:Sprite;
		
		
		public function Timeline()
		{
			/*on crée le background ou les vecteurs vont être arrêtés*/
			_screen = new BitmapData(stage.stageWidth, stage.stageHeight, true, 0xff0000);
			/*on en fait un bitmap*/
			bitmap = new Bitmap(_screen);
			/*on se crée un brouillon avec lequel on va dessiner un cercle et un fond rouge super transparent*/
			sketch = new Sprite();
			
			/*on affiche le bitmap*/
			addChild(bitmap);
			
			/*on crée un curseur de balayage (rouge)*/
			cursor = new Sprite();
			cursor.graphics.beginFill(0x3591C0, 1);
			cursor.graphics.drawRect(0, 0, 1, stage.stageHeight);
			cursor.graphics.endFill();
			
			/*on affiche le curseur*/
			addChildAt(cursor,1);
			
			/*on affecte un evenement ENTERFRAME*/
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}
			
			
		private function onEnterFrame(e:Event):void
		{
			/*on fait avancer le curseur, s'il arrive au bout du stage, on le met à 0*/
			if(cursor.x > stage.stageWidth)	cursor.x =0;
			else	cursor.x++;	
			
			/*on vérifie une distance d'approche entre le curseur et la souris*/
			if(Math.abs(cursor.x - this.mouseX) == 0)
			{
				var eyes_index:int = Math.round(Math.random() * 2);
				var mouth_index:int = Math.round(Math.random() * 2);
				var color_index:int = Math.round(Math.random() * 3);
				
				/*on lance une fonction de création avec les coordonées de la souris*/
				Face.buildFace(sketch, this.mouseX, this.mouseY, eyes_index, mouth_index, color_index);
				/*on copie le dessin du brouillon dans notre background*/
				_screen.draw(sketch);
			}
		}
	}
}